HC = require 'hardoncollider'
require 'console'
text = {}


function love.load()
 Collider = HC(100, on_collide)
 
love.graphics.setBackgroundColor(54, 172, 248)
    bulletSpeed = 1000
    
    bullets = {count=0,x=0,y=0, shape=Collider:addCircle(0,0,2)}
	tables = {x=200,y=200}
    player = {x=250, y=250, velocity=2, img=love.graphics.newImage("images//player.png"), angle=0, hp=100,stamina=50,canrun=true,shape = Collider:addCircle(100,100,10)}
	pistol = {x=0, y=0, img=love.graphics.newImage("images//weapont.png"), angle=0, ammo=15, maxclip=30, canshot=true, damage=5}
	zombies = {x=500, y=500, img=love.graphics.newImage("images//zombie1gc.gif"), angle=0, velocity=120, hp=100,canwalk=true,shape = Collider:addCircle(100,100,10)}
	wall = {shape=Collider:addRectangle(500,550, 50,50)}
	
	
end

function on_collide(dt, shape_a, shape_b)

if shape_a == player.shape then
shape_at = "jogador"
shape_bt = "zumbi"
cmd("drawtxt", shape_at.." colidiu com "..shape_bt)
player.hp = player.hp - 0.7
elseif shape_a == bullets.shape then
shape_at = "bala"
shape_bt = "zumbi"
cmd("drawtxt", shape_at.." colidiu com "..shape_bt)
zombies.hp = zombies.hp - pistol.damage 
end
if shape_a == wall.shape then
if shape_b == zombies.shape then
shape_at = "parede"
shape_bt = "zumbi"
zombies.velocity = 50
cmd("drawtxt", shape_at.." colidiu com "..shape_bt)
elseif shape_b == player.shape then
shape_at = "parede"
shape_bt = "jogador"
player.velocity = 0.7
cmd("drawtxt", shape_at.." colidiu com "..shape_bt)
end
end
	

end

function love.update(dt)

Collider:update(dt)
if pistol.ammo == 0 then
if pistol.maxclip > 0 then
pistol.maxclip = pistol.maxclip-15
pistol.ammo = 15
end
end
if pistol.ammo == 0 and pistol.maxclip == 0 then
pistol.canshot = false
end
pistol.x = player.x
pistol.y = player.y
   local dx = math.cos(zombies.angle) * (dt * zombies.velocity)
   local dy = math.sin(zombies.angle) * (dt * zombies.velocity)
   if zombies.canwalk == true then
   zombies.x = zombies.x - dx
   zombies.y = zombies.y - dy
   end

for i,v in ipairs(bullets) do
        v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
    end
	if love.keyboard.isDown("s") then
	player.y = player.y + player.velocity
	end
	if love.keyboard.isDown("w") then
	player.y = player.y - player.velocity
	end
	if love.keyboard.isDown("a") then
	player.x = player.x - player.velocity
	end
	if love.keyboard.isDown("d") then
	player.x = player.x + player.velocity
	end
	if love.keyboard.isDown("lshift") then
	if player.canrun == true then
	player.stamina = player.stamina -0.8
	if player.velocity < 3.5 then
	player.velocity = player.velocity +0.1
	else
	player.velocity = player.velocity
	end
	end
	else
	player.velocity = 2
	end
	if player.stamina > 50 then
	player.stamina = 50
	end
	if player.stamina > 0 then
	player.canrun = true
	end
	if player.stamina <= 0 then
	player.canrun = false
	player.velocity = 2
	end
	if player.stamina < 50 then
	player.stamina = player.stamina +0.2
	end
	if player.hp < 0 then
	player.x = 250
	player.y = 250
	end
	if zombies.hp <= 0 then
	zombies.canwalk = false
	end
	
	zombies.shape:moveTo(zombies.x,zombies.y)
	player.shape:moveTo(player.x,player.y)
end



function love.draw()
   player.angle = math.atan2 ( player.y - love.mouse.getY(), player.x - love.mouse.getX())
   zombies.angle = math.atan2 ( zombies.y - player.y, zombies.x - player.x)
   pistol.angle = math.atan2 ( pistol.y - love.mouse.getY(), pistol.x - love.mouse.getX())  
for i,v in ipairs(bullets) do
        bullets.shape:draw("fill",2)
		bullets.shape:moveTo(v.x,v.y)
    end

	love.graphics.setColor(0,255,0)
	wall.shape:draw('fill')
	love.graphics.setColor(255,255,255)
	
	
 for i = 1,#text do
        love.graphics.setColor(255,255,255, 255 - (i-1) * 6)
        love.graphics.print(text[#text - (i-1)], 10, i * 15)
    end
	
	love.graphics.setColor(255,255,255)
    love.graphics.print(zombies.hp,zombies.x-10,zombies.y-32)	
	love.graphics.print(player.hp,player.x-10,player.y-32)	
    love.graphics.print("STAMINA: "..math.floor(player.stamina),100,80)
	love.graphics.print(pistol.ammo..":"..pistol.maxclip)
	love.graphics.print(bullets.count,100,10)
    love.graphics.draw(player.img, player.x,player.y,player.angle,sx,sy,player.img:getWidth()/2,player.img:getHeight()/2)
	love.graphics.draw(pistol.img, player.x,player.y, player.angle,sx,sy,pistol.img:getWidth()/2,pistol.img:getHeight()/2)
	love.graphics.draw(zombies.img, zombies.x,zombies.y, zombies.angle,sx,sy,zombies.img:getWidth()/2,zombies.img:getHeight()/2) 
	
	love.graphics.setColor(255,0,0)
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("fill",100,100, player.stamina*2, 20)
	
    
end

function love.mousepressed(x, y, button)
if pistol.canshot == true then
    if button == "l" then
        local startX = player.x -- + player.img:getWidth()/2
        local startY = player.y -- + player.img:getHeight()/2
        local mouseX = x
        local mouseY = y
        local angle = math.atan2((mouseY - startY), (mouseX - startX))
        
        local bulletDx = bulletSpeed * math.cos(angle)
        local bulletDy = bulletSpeed * math.sin(angle)
        table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy})
		bullets.count = bullets.count+1
		pistol.ammo = pistol.ammo - 1
    end
	end

end